SystemOrganization addCategory: #'Discovery-Core'!
SystemOrganization addCategory: #'Discovery-Test'!

TdTimer subclass: #DsServiceEntryPublisher
	instanceVariableNames: 'publisingPorts rbtClient serviceEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsServiceEntryPublisher class methodsFor: 'defaults' stamp: 'mu 3/5/2006 19:57'!
defaultPriority

	^Processor userBackgroundPriority! !

!DsServiceEntryPublisher class methodsFor: 'instance creation' stamp: 'mu 3/6/2006 08:26'!
new
	^self basicNew initialize! !

!DsServiceEntryPublisher class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 20:25'!
on: serviceEntry
	^self new serviceEntry: serviceEntry! !

!DsServiceEntryPublisher methodsFor: 'actions' stamp: 'mu 3/7/2006 09:55'!
addPort: portNumber
	self publisingPorts add: portNumber! !

!DsServiceEntryPublisher methodsFor: 'binding' stamp: 'mu 3/7/2006 09:56'!
bindForBroadcast: portNumber 
	self publisingPorts ifEmpty: [self addPort: portNumber].
	self rbtClient bindForBroadcast: portNumber ! !

!DsServiceEntryPublisher methodsFor: 'binding' stamp: 'mu 3/7/2006 09:56'!
bind: ipAddressOrHost port: portNumber 
	ipAddressOrHost ifNil: [^self bindForBroadcast: portNumber].

	self publisingPorts ifEmpty: [self addPort: portNumber].
	self rbtClient bind: ipAddressOrHost port: portNumber ! !

!DsServiceEntryPublisher methodsFor: 'builder' stamp: 'mu 3/5/2006 20:25'!
buildMessage
	^self serviceEntry lineString ! !

!DsServiceEntryPublisher methodsFor: 'private' stamp: 'mu 3/5/2006 20:59'!
log: anException 
	DsUtil log: anException! !

!DsServiceEntryPublisher methodsFor: 'running' stamp: 'mu 3/5/2006 15:00'!
perform
	self publish! !

!DsServiceEntryPublisher methodsFor: 'running' stamp: 'mu 3/5/2006 15:10'!
publish
	self publisingPorts
		do: [:port | 
			self
				safelyDo: [self send: self buildMessage].
			self waitALittle]! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/1/2006 23:56'!
publisingPort
	self publisingPorts size = 1 ifFalse: [^nil].
	^self publisingPorts first.! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:22'!
publisingPorts
	publisingPorts ifNil: [publisingPorts _ Set new].
	^publisingPorts! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:22'!
publisingPorts: aCollection
	publisingPorts _ aCollection! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/1/2006 23:55'!
publisingPort: portNumber
	self publisingPorts: {portNumber}! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 14:55'!
rbtClient
	rbtClient ifNil: [rbtClient _ RbtClient new].
	^rbtClient! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 14:55'!
rbtClient: aRbtClient
	rbtClient _ aRbtClient! !

!DsServiceEntryPublisher methodsFor: 'actions' stamp: 'mu 3/7/2006 09:55'!
removePort: portNumber
	self publisingPorts remove: portNumber ifAbsent:[]! !

!DsServiceEntryPublisher methodsFor: 'private' stamp: 'mu 3/1/2006 23:28'!
safelyDo: aBlock
	[aBlock value] on: Exception do: [:ex | self log: ex].! !

!DsServiceEntryPublisher methodsFor: 'private' stamp: 'mu 3/6/2006 23:08'!
send: data 
	DsUtil log: data asString.
	self rbtClient sendData: data! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:24'!
serviceEntry
	^serviceEntry! !

!DsServiceEntryPublisher methodsFor: 'accessing' stamp: 'mu 3/6/2006 23:11'!
serviceEntry: aServiceEntry
	serviceEntry _ aServiceEntry.

	self intervalSeconds: aServiceEntry maxAge! !

!DsServiceEntryPublisher methodsFor: 'private' stamp: 'mu 3/1/2006 23:30'!
waitALittle
	(Delay forMilliseconds: 100) wait! !

RbtServer subclass: #DsLocator
	instanceVariableNames: 'entryDict cleanUpProcess entriesProtect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

DsLocator class
	instanceVariableNames: 'locators'!

!DsLocator class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 20:23'!
default
	^self defaultForMulticast! !

!DsLocator class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 20:24'!
defaultForBroadcast
	| inst |
	inst := self named: #defaultForBroadcast.
	inst startOn: DsSettings defaultBroadcastPort.
	^ inst! !

!DsLocator class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 20:24'!
defaultForMulticast
	| inst |
	inst := self named: #defaultForBroadcast.
	inst startOn: DsSettings defaultMulticastPort member: DsSettings defaultMulticastAddress.
	^inst! !

!DsLocator class methodsFor: 'class initialization' stamp: 'mu 3/7/2006 21:01'!
initialize
	"DsLocator initialize"
	super initialize.
	locators ifNotNilDo: [:col | col do:[:each | each stop]].
	locators _ nil! !

!DsLocator class methodsFor: 'accessing' stamp: 'mu 3/7/2006 20:20'!
locators
	locators ifNil: [locators _ IdentityDictionary new].
	^locators! !

!DsLocator class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 20:22'!
named: locatorName 
	| inst |
	inst := self locators
				at: locatorName
				ifAbsentPut: [self new].
	^ inst! !

!DsLocator methodsFor: 'private' stamp: 'mu 3/7/2006 19:58'!
basicStartOn: aPort by: optionSymbol
	super basicStartOn: aPort by: optionSymbol.
	self isRunning
		ifTrue: [self cleanUpProcess start].
	! !

!DsLocator methodsFor: 'builder' stamp: 'mu 3/5/2006 19:45'!
buildCleanUpProcess
	^ TdBlockTimer
		named: self className , ':' , #cleaner
		performBlock: [:timer | self cleanUp]
		intervalSeconds: self cleanUpIntervalSeconds! !

!DsLocator methodsFor: 'cleaning' stamp: 'mu 3/7/2006 20:15'!
cleanUp
	| expiredEntries |
	expiredEntries := self services
				select: [:each | each isExpired].
	expiredEntries
		do: [:each | entriesProtect
				critical: [self entryDict
						removeKey: each id
						ifAbsent: []]]! !

!DsLocator methodsFor: 'defaults' stamp: 'mu 3/5/2006 19:45'!
cleanUpIntervalSeconds
	^10! !

!DsLocator methodsFor: 'accessing' stamp: 'mu 3/5/2006 19:42'!
cleanUpProcess
	cleanUpProcess
		ifNil: [cleanUpProcess := self buildCleanUpProcess].
	^ cleanUpProcess! !

!DsLocator methodsFor: 'accessing' stamp: 'mu 3/5/2006 18:35'!
entryDict
	entryDict ifNil: [entryDict _ IdentityDictionary new].
	^entryDict! !

!DsLocator methodsFor: 'receiving' stamp: 'mu 3/7/2006 20:52'!
handleReceived: entriesString
	| entries |
	DsUtil log: entriesString.
	
	entries _ [DsSeriveEntry readLinesFrom: entriesString] on: Error do: [:ex | DsUtil log: ex description].

	entries do: [:each | 
		entriesProtect critical: [self entryDict at: each id put: each setLastUpdated]
	].! !

!DsLocator methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 20:29'!
initialize
	super initialize.
	self stop.

	entryDict _ cleanUpProcess _ nil.

	"entriesProtect ifNotNilDo: [:p | p terminateProcess]."
	entriesProtect _ Semaphore forMutualExclusion! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/7/2006 21:39'!
serviceNamed: serviceName
	| founds |
	founds _ (self servicesNamed: serviceName).
	founds ifEmpty: [^nil].
	^founds first! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/7/2006 21:32'!
services
	^self entryDict values! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/6/2006 08:12'!
servicesMatches: aBlock
	^self services select: aBlock! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/7/2006 21:30'!
servicesNamed: serviceName
	^self servicesMatches: [:each | each name = serviceName]! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/7/2006 21:31'!
servicesTyped: typeName
	^self servicesMatches: [:each | each type = typeName]! !

!DsLocator methodsFor: 'actions' stamp: 'mu 3/7/2006 21:39'!
serviceTyped: serviceName
	| founds |
	founds _ (self servicesTyped: serviceName).
	founds ifEmpty: [^nil].
	^founds first! !

!DsLocator methodsFor: 'running' stamp: 'mu 3/7/2006 19:59'!
stop
	super stop.
	self cleanUpProcess ifNotNilDo: [:p | p stop]! !

RbtServer subclass: #DsResponder
	instanceVariableNames: 'publisher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsResponder methodsFor: 'private' stamp: 'mu 3/8/2006 21:34'!
anwserFrom: aCollectionOfSearchEntry 
	^ aCollectionOfSearchEntry
		inject: ''
		into: [:sum :each | sum , each lineString]! !

!DsResponder methodsFor: 'receiving' stamp: 'mu 3/8/2006 09:54'!
handleReceived: queryString
	
	DsUtil log: queryString.

	(queryString beginsWith: (DsSearchEntry serchAllHeader)) ifTrue: [self returnSearchAll]! !

!DsResponder methodsFor: 'private' stamp: 'mu 3/8/2006 22:51'!
prepareResponseReturner
	
	| backIp backPort |
	backIp _ self socket remoteAddress.
	backPort _ self socket remotePort.
	"{backIp. backPort} inspect."

	^self prepareResponseReturner: backIp port: backPort.
	! !

!DsResponder methodsFor: 'private' stamp: 'mu 3/8/2006 10:02'!
prepareResponseReturner: ipAddress port: portNumber
	| ipAddressStr client |
	ipAddressStr _ NetNameResolver stringFromAddress: ipAddress.
	client _ RbtClient bind: ipAddressStr port: portNumber.
	^client	! !

!DsResponder methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:24'!
publisher
	^publisher! !

!DsResponder methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:24'!
publisher: aPublisher
	publisher _ aPublisher! !

!DsResponder methodsFor: 'returning' stamp: 'mu 3/8/2006 22:53'!
returnSearchAll
	
	| returner |
	returner _ self prepareResponseReturner.
	returner sendData: (self anwserFrom: self publisher services).! !

RbtClient subclass: #DsSearcher
	instanceVariableNames: 'responseHandler returnSemaphore entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsSearcher class methodsFor: 'private' stamp: 'mu 3/8/2006 22:24'!
bind
	^self bindForMulticast! !

!DsSearcher class methodsFor: 'private' stamp: 'mu 3/8/2006 22:24'!
bindForBroadcast
	^self bindForBroadcast: DsSettings defaultBroadcastPort + 1! !

!DsSearcher class methodsFor: 'private' stamp: 'mu 3/8/2006 22:24'!
bindForMulticast
	^self bind: DsSettings defaultMulticastAddress port: DsSettings defaultMulticastPort + 1! !

!DsSearcher class methodsFor: 'instance creation' stamp: 'mu 3/8/2006 22:23'!
default
	^self bind! !

!DsSearcher class methodsFor: 'instance creation' stamp: 'mu 3/8/2006 22:23'!
defaultForBroadcast
	^self bindForBroadcast! !

!DsSearcher class methodsFor: 'instance creation' stamp: 'mu 3/8/2006 22:23'!
defaultForMulticast
	^self bindForMulticast! !

!DsSearcher methodsFor: 'actions' stamp: 'mu 3/8/2006 09:53'!
bind: ipAddressOrHost port: portNumber 
	super bind: ipAddressOrHost port: portNumber .
	self socket ifNotNilDo: [:sock | self prepareResponseHandler: sock localPort].
	! !

!DsSearcher methodsFor: 'actions' stamp: 'mu 3/5/2006 18:56'!
createSocket
	
	^self createSocketBy: #unicast.
	! !

!DsSearcher methodsFor: 'initialize-release' stamp: 'mu 3/8/2006 21:37'!
initialize
	super initialize.
	returnSemaphore _ Semaphore new.! !

!DsSearcher methodsFor: 'testing' stamp: 'mu 3/5/2006 18:59'!
isValid
	^socket notNil and: [socket isValid]! !

!DsSearcher methodsFor: 'private' stamp: 'mu 3/8/2006 22:54'!
prepareResponseHandler: backPort 
	responseHandler
		ifNotNilDo: [:handler | handler stop].
	responseHandler := (RbtServer startOn: backPort)
				handlerBlock: [:message | 
					DsUtil log: message.
					self searchReturn: message].
	^ responseHandler! !

!DsSearcher methodsFor: 'actions' stamp: 'mu 3/5/2006 18:56'!
releaseSocket
	self responseHandler ifNotNilDo: [:handler | handler release].
	super releaseSocket.
	! !

!DsSearcher methodsFor: 'accessing' stamp: 'mu 3/5/2006 18:52'!
responseHandler
	^responseHandler! !

!DsSearcher methodsFor: 'accessing' stamp: 'mu 3/8/2006 21:39'!
returnSemaphore
	returnSemaphore ifNil: [returnSemaphore _ Semaphore new].
	^returnSemaphore! !

!DsSearcher methodsFor: 'actions-search' stamp: 'mu 3/8/2006 22:19'!
searchAll
	^self searchBy: DsSearchEntry all! !

!DsSearcher methodsFor: 'actions-search' stamp: 'mu 3/8/2006 22:50'!
searchBy: searchEntry 
	"Since this is UDP, you can not always get a correct answer."
	entries := nil.
	self sendData: searchEntry lineString.
	self returnSemaphore waitTimeoutSeconds: 1.
	entries
		ifNil: [[self returnSemaphore isEmpty]
				whileFalse: [self returnSemaphore signal].
			entries := #()].
	^ entries! !

!DsSearcher methodsFor: 'callback' stamp: 'mu 3/8/2006 21:40'!
searchReturn: answer
	DsUtil log: answer.
	entries _ DsSeriveEntry readLinesFrom: answer.
	self returnSemaphore signal.
	^entries! !

TestCase subclass: #DsDiscoveryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Test'!

!DsDiscoveryTest methodsFor: 'testing' stamp: 'mu 3/8/2006 07:54'!
testBroadcastDiscovery
	"self debug: #testBroadcastDiscovery"
	| loc pub |
	[loc := DsLocator defaultForBroadcast.
	self
		should: [(loc serviceNamed: 'superSwikiService1') isNil].
	pub := DsPublisher defaultForBroadcast.
	pub
		registerServiceNamed: 'superSwikiService1'
		host: 'localhost'
		port: 8080
		maxAge: 3.
	pub
		registerServiceNamed: 'otherSomeService1'
		host: 'localhost'
		port: 9090
		maxAge: 3.
	(Delay forSeconds: 3) wait.
	self
		shouldnt: [(loc servicesNamed: 'superSwikiService1') isNil].
	self
		shouldnt: [(loc servicesNamed: 'otherSomeService1') isNil].
	pub removeServiceNamed: 'superSwikiService1'.
	pub removeServiceNamed: 'otherSomeService1'.
	self
		should: [(loc serviceNamed: 'superSwikiService1') isNil].
	self
		should: [(loc serviceNamed: 'otherSomeService1') isNil]]
		ensure: [pub removeServiceNamed: 'superSwikiService1'.
			pub removeServiceNamed: 'otherSomeService1']! !

!DsDiscoveryTest methodsFor: 'testing' stamp: 'mu 3/8/2006 22:57'!
testBroadcastSearch
	"self debug: #testBroadcastSearch"
	| pub searcher entries |
	[pub := DsPublisher defaultForBroadcast.
	pub
		registerServiceNamed: 'superSwikiService1'
		host: 'localhost'
		port: 8080
		maxAge: 2.
	pub
		registerServiceNamed: 'otherSomeService1'
		host: 'localhost'
		port: 9090
		maxAge: 2.
	(Delay forSeconds: 3) wait.
	
	searcher _ DsSearcher defaultForBroadcast.
	entries _ searcher searchAll.
	self should: [entries includes: (DsSeriveEntry name: 'superSwikiService1' host: 'localhost' port: 8080 maxAge: 2 )].
	self should: [entries includes: (DsSeriveEntry name: 'otherSomeService1' host: 'localhost' port: 9090 maxAge: 2 )].
	
	pub removeServiceNamed: 'superSwikiService1'.
	pub removeServiceNamed: 'otherSomeService1'.

	entries _ searcher searchAll.
	self shouldnt: [entries includes: (DsSeriveEntry name: 'superSwikiService1' host: 'localhost' port: 8080 maxAge: 2 )].
	self shouldnt: [entries includes: (DsSeriveEntry name: 'otherSomeService1' host: 'localhost' port: 9090 maxAge: 2 )].

	] ensure: [searcher release.
			pub removeServiceNamed: 'superSwikiService1'.
			pub removeServiceNamed: 'otherSomeService1']! !

!DsDiscoveryTest methodsFor: 'testing' stamp: 'mu 3/8/2006 07:55'!
testMulticastDiscovery
	"self debug: #testMulticastDiscovery"
	| loc pub |
	[loc := DsLocator defaultForMulticast.
	self
		should: [(loc serviceNamed: 'superSwikiService1') isNil].
	pub := DsPublisher defaultForMulticast.
	pub
		registerServiceNamed: 'superSwikiService1'
		host: 'localhost'
		port: 8080
		maxAge: 3.
	pub
		registerServiceNamed: 'otherSomeService1'
		host: 'localhost'
		port: 9090
		maxAge: 3.
	(Delay forSeconds: 3) wait.
	self
		shouldnt: [(loc servicesNamed: 'superSwikiService1') isNil].
	self
		shouldnt: [(loc servicesNamed: 'otherSomeService1') isNil].
	pub removeServiceNamed: 'superSwikiService1'.
	pub removeServiceNamed: 'otherSomeService1'.
	self
		should: [(loc serviceNamed: 'superSwikiService1') isNil].
	self
		should: [(loc serviceNamed: 'otherSomeService1') isNil]]
		ensure: [pub removeServiceNamed: 'superSwikiService1'.
			pub removeServiceNamed: 'otherSomeService1']! !

!DsDiscoveryTest methodsFor: 'testing' stamp: 'mu 3/8/2006 22:58'!
testMulticastSearch
	"self debug: #testMulticastSearch"
	| pub searcher entries |
	[pub := DsPublisher defaultForMulticast.
	pub
		registerServiceNamed: 'superSwikiService1'
		host: 'localhost'
		port: 8080
		maxAge: 2.
	pub
		registerServiceNamed: 'otherSomeService1'
		host: 'localhost'
		port: 9090
		maxAge: 2.
	(Delay forSeconds: 3) wait.
	
	searcher _ DsSearcher defaultForMulticast.
	entries _ searcher searchAll.
	self should: [entries includes: (DsSeriveEntry name: 'superSwikiService1' host: 'localhost' port: 8080 maxAge: 2 )].
	self should: [entries includes: (DsSeriveEntry name: 'otherSomeService1' host: 'localhost' port: 9090 maxAge: 2 )].
	
	pub removeServiceNamed: 'superSwikiService1'.
	pub removeServiceNamed: 'otherSomeService1'.

	entries _ searcher searchAll.
	self shouldnt: [entries includes: (DsSeriveEntry name: 'superSwikiService1' host: 'localhost' port: 8080 maxAge: 2 )].
	self shouldnt: [entries includes: (DsSeriveEntry name: 'otherSomeService1' host: 'localhost' port: 9090 maxAge: 2 )].

	] ensure: [searcher release.
			pub removeServiceNamed: 'superSwikiService1'.
			pub removeServiceNamed: 'otherSomeService1']! !

!DsDiscoveryTest methodsFor: 'testing' stamp: 'mu 3/7/2006 21:24'!
testServiceRegister
	"self debug: #testServiceRegister"
	| pub |
	pub _ DsPublisher new.
	pub port: DsSettings defaultBroadcastPort.
	
	pub registerServiceNamed: 'testService1' location: '192.168.1.1:8080' maxAge: 30 .
	pub registerServiceNamed: 'testService2' host: '192.168.1.1' port:8081 maxAge: 10 .

	self should: [pub services size = 2].

	pub removeServiceNamed: 'testService1'.
	pub registerServiceNamed: 'testService2' host: '192.168.1.1' port:8081 maxAge: 5 .

	self should: [pub services size = 1].

	self should: [pub services asArray first maxAge = 5].

	pub stop; initialize! !

Object subclass: #DsPublisher
	instanceVariableNames: 'entryPublishers port memberAddress responder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

DsPublisher class
	instanceVariableNames: 'publishers'!

!DsPublisher class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 20:20'!
default
	^self defaultForMulticast! !

!DsPublisher class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 21:37'!
defaultForBroadcast
	| inst |
	inst := self named: #defaultForBroadcast.
	inst port: DsSettings defaultBroadcastPort.
	inst start.
	^ inst! !

!DsPublisher class methodsFor: 'instance creation' stamp: 'mu 3/7/2006 21:37'!
defaultForMulticast
	| inst |
	inst := self named: #defaultForMulticast.
	inst memberAddress: DsSettings defaultMulticastAddress.
	inst port: DsSettings defaultMulticastPort.
	inst start.
	^ inst! !

!DsPublisher class methodsFor: 'class initialization' stamp: 'mu 3/7/2006 21:01'!
initialize
	super initialize.
	publishers ifNotNilDo: [:col | col do:[:each | each stop]].
	publishers _ nil! !

!DsPublisher class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 20:21'!
named: publisherName 
	| inst |
	inst := self publishers
				at: publisherName
				ifAbsentPut: [self new].
	^ inst! !

!DsPublisher class methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:19'!
publishers
	publishers ifNil: [publishers _ IdentityDictionary new].
	^publishers! !

!DsPublisher methodsFor: 'private' stamp: 'mu 3/7/2006 21:09'!
basicRegisterService: serviceEntry 
	| oldEntryPublisher newEntryPublisher |
	(oldEntryPublisher := self entryPublishers
					detect: [:each | each serviceEntry = serviceEntry]
					ifNone: []) notNil
		ifTrue: [^ oldEntryPublisher serviceEntry: serviceEntry].

	newEntryPublisher := self serviceEntryPublisherClass on: serviceEntry.
	self isMulticast
		ifTrue: [newEntryPublisher bind: self memberAddress port: self port]
		ifFalse: [newEntryPublisher bindForBroadcast: self port].
	newEntryPublisher start.
	^ self entryPublishers add: newEntryPublisher! !

!DsPublisher methodsFor: 'private' stamp: 'mu 3/5/2006 20:44'!
basicRemoveService: serviceEntry
	| removedEntryPublishers |
	removedEntryPublishers _ self entryPublishers select: [:each | each serviceEntry = serviceEntry].
	removedEntryPublishers do: [:each | each stop].
	self entryPublishers removeAllSuchThat: [:each | each serviceEntry = serviceEntry]! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:27'!
entryPublishers
	entryPublishers ifNil: [entryPublishers _ Set new].
	^entryPublishers! !

!DsPublisher methodsFor: 'initialize-release' stamp: 'mu 3/5/2006 20:57'!
initialize

	entryPublishers ifNotNilDo: [:pubs | pubs do: [:each | each stop]].
	entryPublishers _ nil.
	port _ memberAddress _ nil.! !

!DsPublisher methodsFor: 'testing' stamp: 'mu 3/7/2006 09:53'!
isMulticast
	^self memberAddress notNil! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:51'!
memberAddress
	"nil means broadcast"
	^memberAddress! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:51'!
memberAddress: addressString
	"nil means broadcast"
	^memberAddress _ addressString! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:50'!
port
	^port! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:50'!
port: anInteger
	port _ anInteger asString asInteger! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 23:14'!
registerServiceNamed: serviceName host: ipOrHostString port: portNumber maxAge: seconds 
	| service |
	service := DsSeriveEntry
				name: serviceName
				host: ipOrHostString port: portNumber
				maxAge: seconds.
	^self basicRegisterService: service! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 23:15'!
registerServiceNamed: serviceName location: ipAndPortOrURL maxAge: seconds 
	| service |
	service := DsSeriveEntry
				name: serviceName
				location: ipAndPortOrURL
				maxAge: seconds.
	^self basicRegisterService: service! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 23:15'!
registerServiceType: serviceType version: versionString name: serviceName host: ipOrHostString port: portNumber maxAge: seconds 
	| entry |
	entry := DsSeriveEntry
				type: serviceType
				version: versionString
				name: serviceName
				host: ipOrHostString port: portNumber
				maxAge: seconds.
	^self basicRegisterService: entry! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 23:15'!
registerServiceType: serviceType version: versionString name: serviceName location: ipAndPOrtOrURL maxAge: seconds 
	| entry |
	entry := DsSeriveEntry
				type: serviceType
				version: versionString
				name: serviceName
				location: ipAndPOrtOrURL
				maxAge: seconds.
	^self basicRegisterService: entry! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/7/2006 21:46'!
registerService: serviceEntry

	^ self basicRegisterService: (self serviceEntryFrom: serviceEntry)! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 21:41'!
removeServiceNamed: serviceName
	| service |
	service := DsSeriveEntry
				name: serviceName
				location: ''
				maxAge: 0.
	^self basicRemoveService: service

	! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 21:38'!
removeServiceType: serviceType version: versionString name: serviceName
	| service |
	service := DsSeriveEntry
				type: serviceType
				version: versionString
				name: serviceName
				location: ''
				maxAge: 0.
	^self basicRemoveService: service

	! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/7/2006 21:46'!
removeService: serviceEntry

	^ self basicRemoveService: (self serviceEntryFrom: serviceEntry)! !

!DsPublisher methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:22'!
responder
	responder ifNil: [self startResponder].
	^responder! !

!DsPublisher methodsFor: 'private' stamp: 'mu 3/5/2006 20:32'!
serviceEntryFrom: aServiceThing 
	| entry |
	(aServiceThing isMemberOf: DsSeriveEntry)
		ifTrue: [entry := aServiceThing].
	aServiceThing isString
		ifTrue: [entry := DsSeriveEntry readFrom: aServiceThing].
	(aServiceThing isMemberOf: Dictionary)
		ifTrue: [entry := DsSeriveEntry fromDictionary: aServiceThing].
	^ entry! !

!DsPublisher methodsFor: 'factory' stamp: 'mu 3/5/2006 20:35'!
serviceEntryPublisherClass
	^DsServiceEntryPublisher
	! !

!DsPublisher methodsFor: 'accessing-services' stamp: 'mu 3/6/2006 21:45'!
services
	^self entryPublishers collect:[:each | each serviceEntry]! !

!DsPublisher methodsFor: 'running' stamp: 'mu 3/8/2006 08:22'!
start
	self entryPublishers do: [:each | each start].
	self startResponder! !

!DsPublisher methodsFor: 'private' stamp: 'mu 3/8/2006 21:25'!
startResponder
	self stopResponder.
	responder := self isMulticast
				ifTrue: [DsResponder startOn: DsSettings defaultMulticastPort + 1 member: DsSettings defaultMulticastAddress]
				ifFalse: [DsResponder startOn: DsSettings defaultBroadcastPort + 1].
	responder publisher: self.
	^responder! !

!DsPublisher methodsFor: 'running' stamp: 'mu 3/8/2006 08:23'!
stop
	self entryPublishers do: [:each | each stop].
	self stopResponder! !

!DsPublisher methodsFor: 'private' stamp: 'mu 3/8/2006 08:22'!
stopResponder
	responder
		ifNotNilDo: [:res | res stop].
	! !

Object subclass: #DsSearchEntry
	instanceVariableNames: 'serviceEntry isAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsSearchEntry class methodsFor: 'instance creation' stamp: 'mu 3/8/2006 08:00'!
all
	^self new! !

!DsSearchEntry class methodsFor: 'constants' stamp: 'mu 3/8/2006 19:48'!
serchAllHeader
	^'Search*'! !

!DsSearchEntry class methodsFor: 'constants' stamp: 'mu 3/8/2006 08:26'!
serchHeader
	^'Search'! !

!DsSearchEntry methodsFor: 'constants' stamp: 'mu 3/8/2006 08:27'!
header
	^ self isAll
		ifTrue: [self class serchAllHeader]
		ifFalse: [self class serchHeader]! !

!DsSearchEntry methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:05'!
isAll
	isAll ifNil: [isAll _ true].
	^isAll! !

!DsSearchEntry methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:04'!
isAll: aBoolean
	isAll _ aBoolean! !

!DsSearchEntry methodsFor: 'printing' stamp: 'mu 3/8/2006 08:06'!
lineString
	^String streamContents: [:str |
		str nextPutAll: self header; tab.
		self serviceEntry ifNotNilDo: [:ent | str nextPutAll: ent lineString].
		str cr.
	]! !

!DsSearchEntry methodsFor: 'printing' stamp: 'mu 3/8/2006 08:06'!
printOn: aStream 
	aStream nextPutAll: '['.
	aStream nextPutAll: self lineString.
	aStream skip: -1.
	aStream nextPutAll: ']'.! !

!DsSearchEntry methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:00'!
serviceEntry
	^serviceEntry! !

!DsSearchEntry methodsFor: 'accessing' stamp: 'mu 3/8/2006 08:00'!
serviceEntry: aServiceEntry
	serviceEntry _ aServiceEntry! !

!DsSearchEntry methodsFor: 'printing' stamp: 'mu 3/8/2006 08:07'!
storeString
	^self lineString! !

Object subclass: #DsSeriveEntry
	instanceVariableNames: 'name type location version maxAge lastUpdatedTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsSeriveEntry class methodsFor: 'examples' stamp: 'mu 3/5/2006 15:17'!
example1
	"DsSeriveEntry example1"
	| inst str |
	inst _ self name: 'Service1' location: 'localshot:8823' maxAge: 200 .
	str _ inst lineString.

	(DsSeriveEntry readFrom: str) inspect! !

!DsSeriveEntry class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 19:09'!
fromDictionary: aDictionary
	| inst |
	inst _ self new.
	aDictionary keysAndValuesDo: [:key :value |
		inst perform: (key, ':') asSymbol with: value
	].
	^inst! !

!DsSeriveEntry class methodsFor: 'utilities' stamp: 'mu 3/6/2006 21:34'!
ipAndPortStringFrom: ipOrHostString port: portNumber
	^ipOrHostString asString, ':', portNumber asString! !

!DsSeriveEntry class methodsFor: 'instance creation' stamp: 'mu 3/6/2006 21:40'!
name: serviceName host: ipOrHostString port: portNumber maxAge: secs 
	| inst |
	inst := self new.
	inst name: serviceName.
	inst location: (self ipAndPortStringFrom: ipOrHostString port: portNumber).
	inst maxAge: secs.
	^ inst! !

!DsSeriveEntry class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 19:51'!
name: serviceName location: ipAndPOrtOrURL maxAge: secs 
	| inst |
	inst := self new.
	inst name: serviceName.
	inst location: ipAndPOrtOrURL.
	inst maxAge: secs.
	^ inst! !

!DsSeriveEntry class methodsFor: 'reading' stamp: 'mu 3/7/2006 20:41'!
readFrom: aStreamOrString 
	^ self readLineFrom: aStreamOrString! !

!DsSeriveEntry class methodsFor: 'reading' stamp: 'mu 3/5/2006 19:14'!
readLineFrom: aStreamOrString
	| str tabChar inst |
	aStreamOrString ifNil: [^nil].
	str := aStreamOrString isString
				ifTrue: [aStreamOrString readStream]
				ifFalse: [aStreamOrString].
	tabChar _ Character tab.
	inst _ self new.
	[str atEnd] whileFalse: [
		inst type: (str upTo: tabChar).
		inst version: (str upTo: tabChar).
		inst name: (str upTo: tabChar).
		inst location: (str upTo: tabChar).
		inst maxAge: (str upTo: tabChar).
	].
	^inst

	! !

!DsSeriveEntry class methodsFor: 'reading' stamp: 'mu 3/7/2006 20:43'!
readLinesFrom: linesStream
	| crChar str entries |
	crChar _ Character cr.
	entries _ OrderedCollection new.
	linesStream ifNil: [^#()].
	str := linesStream isString
				ifTrue: [linesStream readStream]
				ifFalse: [linesStream].
	[str atEnd] whileFalse: [ 
		entries add: (self readLineFrom: (str upTo: crChar)).
	].
	^entries! !

!DsSeriveEntry class methodsFor: 'instance creation' stamp: 'mu 3/6/2006 21:39'!
type: serviceType version: versionString name: serviceName host: ipOrHostString port: portNumber maxAge: secs 
	| inst |
	inst := self new.
	inst type: serviceType.
	inst version: versionString.
	inst name: serviceName.
	inst location: (self ipAndPortStringFrom: ipOrHostString port: portNumber).
	inst maxAge: secs.
	^ inst! !

!DsSeriveEntry class methodsFor: 'instance creation' stamp: 'mu 3/5/2006 19:51'!
type: serviceType version: versionString name: serviceName location: ipAndPOrtOrURL maxAge: secs 
	| inst |
	inst := self new.
	inst type: serviceType.
	inst version: versionString.
	inst name: serviceName.
	inst location: ipAndPOrtOrURL.
	inst maxAge: secs.
	^ inst! !

!DsSeriveEntry methodsFor: 'converting' stamp: 'mu 3/5/2006 14:34'!
asDictionary
	| dict |
	dict _ Dictionary new.
	dict at: #name put: self name.
	dict at: #type put: self type.
	dict at: #location put: self location.
	dict at: #version put: self version.
	dict at: #maxAge put: self maxAge.
	^dict! !

!DsSeriveEntry methodsFor: 'comparing' stamp: 'mu 3/6/2006 21:47'!
hash
	^self id hash! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/6/2006 08:31'!
id
	^(String streamContents: [:str |
		str nextPutAll: self type; tab.
		str nextPutAll: self version asString; tab.
		str nextPutAll: self name; tab.
	]) asSymbol! !

!DsSeriveEntry methodsFor: 'initialize-release' stamp: 'mu 3/5/2006 19:51'!
initialize
	name _ ''.
	type _ #General.
	location _ ''.
	version _ '0'.
	maxAge _ 30! !

!DsSeriveEntry methodsFor: 'testing' stamp: 'mu 3/7/2006 20:57'!
isExpired
	^(Time millisecondClockValue - self lastUpdatedTimestamp) abs > ((self maxAge * 1000) * 2)! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/6/2006 07:58'!
lastUpdatedTimestamp
	lastUpdatedTimestamp ifNil: [self setLastUpdated].
	^lastUpdatedTimestamp! !

!DsSeriveEntry methodsFor: 'printing' stamp: 'mu 3/2/2006 00:13'!
lineString
	^String streamContents: [:str |
		str nextPutAll: self type; tab.
		str nextPutAll: self version asString; tab.
		str nextPutAll: self name; tab.
		str nextPutAll: self location; tab.
		str nextPutAll: self maxAge asString; cr.
	]! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
location

	^location! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
location: aValue

	location := aValue! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
maxAge

	^maxAge! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/2/2006 00:23'!
maxAge: aValue

	maxAge := aValue asString asInteger! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
name

	^name! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/2/2006 00:23'!
name: aValue

	name := aValue asString! !

!DsSeriveEntry methodsFor: 'printing' stamp: 'mu 3/6/2006 21:48'!
printOn: aStream 
	aStream nextPutAll: '['.
	aStream nextPutAll: self lineString.
	aStream skip: -1.
	aStream nextPutAll: ']'.! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/6/2006 07:58'!
setLastUpdated
	lastUpdatedTimestamp _ Time millisecondClockValue! !

!DsSeriveEntry methodsFor: 'printing' stamp: 'mu 3/2/2006 00:14'!
storeString
	^self lineString! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
type

	^type! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/2/2006 00:24'!
type: aValue

	type := aValue asString! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/1/2006 22:40'!
version

	^version! !

!DsSeriveEntry methodsFor: 'accessing' stamp: 'mu 3/2/2006 00:23'!
version: aValue

	version := aValue asString! !

!DsSeriveEntry methodsFor: 'comparing' stamp: 'mu 3/5/2006 18:32'!
= other
	self class ~= other class ifTrue: [^false].
	^self id = other id! !

Object subclass: #DsSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

DsSettings class
	instanceVariableNames: 'settingsDict isDebugging'!

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 21:08'!
defaultBroadcastPort
	^self settingsDict at: #defaultBroadcastPort ifAbsentPut:[9182]! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:46'!
defaultBroadcastPort: port
	self settingsDict at: #defaultBroadcastPort put: port! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:45'!
defaultIntervalSeconds
	^self settingsDict at: #defaultIntervalSeconds ifAbsentPut:[12]! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:46'!
defaultIntervalSeconds: seconds
	self settingsDict at: #defaultIntervalSeconds put: seconds! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:45'!
defaultMulticastAddress
	^self settingsDict at: #defaultMulticastAddress ifAbsentPut:['239.255.255.123']! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:46'!
defaultMulticastAddress: addressString
	
	self settingsDict at: #defaultMulticastAddress put: addressString! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:45'!
defaultMulticastPort
	^self settingsDict at: #defaultMulticastPort ifAbsentPut:[9180]! !

!DsSettings class methodsFor: 'defaults' stamp: 'mu 3/5/2006 15:47'!
defaultMulticastPort: port
	
	self settingsDict at: #defaultMulticastPort put: port! !

!DsSettings class methodsFor: 'class initialization' stamp: 'mu 3/5/2006 20:18'!
initialize
	isDebugging _ nil.
	settingsDict _ nil.
	! !

!DsSettings class methodsFor: 'accessing' stamp: 'mu 3/5/2006 20:19'!
isDebugging
	isDebugging ifNil: [isDebugging _ false].
	^isDebugging! !

!DsSettings class methodsFor: 'accessing' stamp: 'mu 3/6/2006 23:08'!
isDebugging: aBoolean
	"DsSettings isDebugging: true"
	"DsSettings isDebugging: false"

	isDebugging _ aBoolean == true! !

!DsSettings class methodsFor: 'accessing' stamp: 'mu 3/5/2006 15:41'!
settingsDict
	settingsDict ifNil: [settingsDict _ IdentityDictionary new].
	^settingsDict! !

Object subclass: #DsUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Discovery-Core'!

!DsUtil class methodsFor: 'actions' stamp: 'mu 3/7/2006 20:54'!
logError: anException 
	"DsUtil log: anException"
	DsSettings isDebugging
		ifTrue: [Transcript cr; show: thisContext sender sender asString , ': ' , anException description.
			anException return]! !

!DsUtil class methodsFor: 'actions' stamp: 'mu 3/7/2006 20:53'!
log: anExceptionOrString 
	"DsUtil log: 'hello'"
	(anExceptionOrString isKindOf: Exception)
		ifTrue: [^self logError: anExceptionOrString].

	DsSettings isDebugging
		ifTrue: [Transcript cr; show: thisContext sender asString , ' ' , anExceptionOrString]
		! !
DsLocator initialize!
DsPublisher initialize!
DsSettings initialize!
